;------------------------------
; Marble Craze bank 5
;------------------------------
; Includes:
;	level control data
;	some game logic
;------------------------------

	org $5000
	rorg $1000


accArray
	
	byte 252,0,252,0,252,0,252,0
	byte 252,0,252,0,252,0,252,0

	byte 252,0,0,252,0,252,0,252
	byte 0,0,252,0,252,0,252,0

	byte 252,0,0,252,0,0,252,0
	byte 252,0,0,252,0,0,252,0

	byte 252,0,0,252,0,0,252,0
	byte 0,252,0,0,252,0,0,0


	byte 252,0,0,0,252,0,0,0
	byte 252,0,0,0,252,0,0,0

	byte 252,0,0,0,0,252,0,0
	byte 0,0,252,0,0,0,0,0

	byte 252,0,0,0,0,0,0,0
	byte 252,0,0,0,0,0,0,0

	byte 252,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0

	
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0

	byte 4,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	
	byte 4,0,0,0,0,0,0,0
	byte 4,0,0,0,0,0,0,0

	byte 4,0,0,0,0,4,0,0
	byte 0,0,4,0,0,0,0,0


	byte 4,0,0,0,4,0,0,0
	byte 4,0,0,0,4,0,0,0

	byte 4,0,0,4,0,0,4,0
	byte 0,4,0,0,4,0,0,0

	byte 4,0,0,4,0,0,4,0
	byte 4,0,0,4,0,0,4,0

	byte 4,0,0,4,0,4,0,4
	byte 0,0,4,0,4,0,4,0


speedArray
	byte 0,0,0,0,0,0,0,0 ;1
	byte 0,0,0,0,0,0,0,0 ;1
	byte 1,0,0,0,0,0,0,0 ;2
	byte 1,0,0,0,1,0,0,0 ;3
	byte 1,0,0,1,0,0,1,0 ;4
	byte 1,0,1,0,1,0,1,0 ;5
	byte 1,1,0,1,0,1,0,1 ;6
	byte 1,1,1,0,1,1,1,0 ;7
	byte 1,1,1,1,1,1,1,0 ;8
	byte 1,1,1,1,1,1,1,1 ;9
	byte 2,1,1,1,1,1,1,1 ;10
	byte 2,1,1,1,2,1,1,1 ;11
	byte 2,1,1,2,1,1,2,1 ;12
	byte 2,1,2,1,2,1,1,2 ;13
	byte 2,1,2,2,1,2,2,1 ;14
	byte 2,2,2,1,2,2,2,1 ;15
	byte 2,2,2,2,2,2,2,1 ;16
	byte 2,2,2,2,2,2,2,2 ;17
	byte 3,2,2,2,2,2,2,2 ;18
	byte 3,2,2,2,3,2,2,2 ;19
	byte 3,2,2,3,2,2,3,2 ;20
	byte 3,2,3,2,3,2,3,2 ;21
	byte 3,3,2,3,3,2,3,2 ;22
	byte 3,3,3,2,3,3,3,2 ;23
	byte 3,3,3,3,3,3,3,2 ;24
	byte 3,3,3,3,3,3,3,3 ;25
	byte 4,3,3,3,3,3,3,3 ;26
	byte 4,3,3,3,4,3,3,3 ;27
	byte 4,3,3,4,3,3,4,3 ;28
	byte 4,3,4,3,4,3,4,3 ;29
	byte 4,4,3,4,4,3,4,3 ;30
	byte 4,4,4,3,4,4,4,3 ;31
	


paddleDecode2
	byte 0,0,0,0,0,0,1,1,1,1,1,1,1
	byte 2,2,2,2,2,2,3,3,3,3,3,3,3
	byte 4,4,4,4,4,4,5,5,5,5,5,5,5
	byte 5,5,5,5,5,5,6,6,6,6,6,6,6
	byte 6,6,6,6,6,6,7,7,7,7,7,7,7
	byte 7,7,7,7,7,7,8,8,8,8,8,8,8
	byte 8,8,8,8,8,8,8,8,8,8,8,8,8
	byte 9,9,9,9,9,9,9,9,9,9,9,9,9
	byte 10,10,10,10,10,10,10,10,10,10,10,10,10
	byte 11,11,11,11,11,11,11,11,11,11,11,11,11
	byte 12,12,12,12,12,12,12,12,12,12,12,12,12
	byte 13,13,13,13,13,13,14,14,14,14,14,14,14
	byte 15,15,15,15,15,15



;--------------------------------------------------------------------------
; Takes a paddle position, position, and speed, and calculates the
; new speed and position.
;
; Preload:
; A: paddle position
; Y: speed
; temp2: position
;
; Returns:
; temp: speed
; A: position
;--------------------------------------------------------------------------
calcMovement
	ldx temp2

	sty temp16H

	
	; The acceleration speed is determined by
	; the 4 high bits
	asl
	asl
	asl
	asl
	sta temp

	; Set the current step of acceleration
	lda frame
	and #%00001111
	clc
	adc temp

	; Determine the amount of acceleration
	; for this frame
	tax
	lda accArray,x

	sta temp
	tya
	
	; Add it to the current speed
	clc
	adc temp


	; Check for max speeds
	cmp #0
	beq noSetVal

	cmp #248
	beq noSetVal

	; Set the speed
	;sta temp16H
	tay

noSetVal

	; Get the new speed	
	tya
	;lda temp16H

	; If it's positive speed, go to 
	; the positive speed handler
	bmi posVel

	; Negative speed handler

	; Invert the speed
	asl
	sta temp
	lda #0
	sbc temp
	
	; Set up the current frame
	sta temp
	lda frame
	and #%00000111
	adc temp

	; Get the current speed increment
	tax
	lda speedArray,x

	; Subtract the increment from
	; the current position
	sta temp
	lda temp2
	sec
	sbc temp

	jmp endVel

posVel
	asl

	; Set up the frame counter
	sta temp
	lda frame
	and #%00000111
	adc temp

	; Get the current speed increment
	tax
	lda speedArray,x

	; Add it to the position
	clc
	adc temp2

endVel
	
	; Y = speed
	; A = position

	rts



; MAY READ 1 LEVEL CONTROL BYTE PER CALL
;--------------------------------------------------------------------------
; checkYPosition
;--------------------------------------------------------------------------
; Takes current X position and new proposed Y position and checks
; for falling off, edge of screen, or walls.
;
; (Currently just loops)
; 
; Preload:
; A: position
; Y: velocity
;
; Returns:
; A: position
; Y: velocity
;
;--------------------------------------------------------------------------
checkYPosition
	
	; Transfer velocity from Y to X
	sty temp
	ldx temp

	cmp #2
	beq topReset
	cmp #3
	beq topReset
	cmp #4
	beq topReset
	cmp #5
	beq topReset

	cmp #157
	beq bottomReset
	cmp #156
	beq bottomReset
	cmp #155
	beq bottomReset
	cmp #154
	beq bottomReset
	jmp noResetY

topReset
	ldy #0
	lda (screenL),y
	
	bmi topStop

	; preserve wall/falling flags
	sta temp2
	lda #%11100000
	and screen
	ora temp2
	
	; Set next screen
	sta screen

	lda #SCREENLOAD
	sta status

	lda #152
	jmp noResetY

topStop
	; set velocity to zero
	ldx #128

	lda #6
	jmp noResetY



bottomReset

	ldy #1
	lda (screenL),y
	
	bmi bottomStop

	; preserve wall/falling flags
	sta temp2
	lda #%11100000
	and screen
	ora temp2
	
	; Set next screen
	sta screen

	lda #SCREENLOAD
	sta status

	lda #7
	jmp noResetY

bottomStop
	; set velocity to zero
	ldx #158

	lda #142
	jmp noResetY


noResetY

	; move velocity from X to Y
	stx temp
	ldy temp
	
	jmp rtnCheckYPosition


; MAY READ 1 LEVEL CONTROL BYTE PER CALL
;--------------------------------------------------------------------------
; checkXPosition
;--------------------------------------------------------------------------
; Takes current Y position and new proposed X position and checks
; for falling off, edge of screen, or walls.
;
; (Currently just loops)
; 
; Preload:
; A: X position
; Y: X velocity
;
; Returns:
; A: updated X position
; Y: updated X velocity (may stop if hit wall or side)
;
;--------------------------------------------------------------------------
checkXPosition

	sty temp
	ldx temp

	cmp #1
	beq leftReset
	cmp #2
	beq leftReset
	cmp #3
	beq leftReset
	cmp #4
	beq leftReset

	cmp #142
	beq rightReset
	cmp #143
	beq rightReset
	cmp #144
	beq rightReset
	cmp #145
	beq rightReset
	jmp noResetX

leftReset
	ldy #2
	lda (screenL),y
	
	bmi leftStop

	; preserve wall/falling flags
	sta temp2
	lda #%11100000
	and screen
	ora temp2
	
	; set next screen
	sta screen

	lda #SCREENLOAD
	sta status

	; Remove any Y movement since we're jumping screens
	stx temp2
	ldx player
	lda pMarble2+1
	sta p1y,x
	ldx temp2	


	lda #141
	jmp noResetX

leftStop
	ldx #128
	lda #5
	jmp noResetX


rightReset
	ldy #3
	lda (screenL),y

	bmi rightStop

	; preserve wall/falling flags
	sta temp2
	lda #%11100000
	and screen
	ora temp2
	
	; set next screen
	sta screen

	; Remove any Y movement since we're jumping screens
	stx temp2
	ldx player
	lda pMarble2+1
	sta p1y,x
	ldx temp2	

	lda #SCREENLOAD
	sta status

	lda #6
	jmp noResetX

rightStop
	; set velocity to zero
	ldx #128
	lda #141
	
noResetX

	stx temp
	ldy temp

	jmp rtnCheckXPosition





collisions
	byte %00010001,0,0,0
	byte %00100010,0,0,0
	byte %01000100,0,0,0
	byte %10001000,0,0,0

	byte 0,%10000000,0,0
	byte 0,%01000000,0,0
	byte 0,%00100000,0,0
	byte 0,%00010000,0,0
	byte 0,%00001000,0,0
	byte 0,%00000100,0,0
	byte 0,%00000010,0,0
	byte 0,%00000001,0,0

	byte 0,0,%00000001,0
	byte 0,0,%00000010,0
	byte 0,0,%00000100,0
	byte 0,0,%00001000,0
	byte 0,0,%00010000,0
	byte 0,0,%00100000,0
	byte 0,0,%01000000,0
	byte 0,0,%01000000,0

	byte 0,0,%01000000,0

div3t4
	byte 0,0,0
	byte 4,4,4,4,4,4,4,4
	byte 8,8,8,8,8,8,8,8
	byte 12,12,12,12,12,12,12,12
	byte 16,16,16,16,16,16,16,16
	byte 20,20,20,20,20,20,20,20
	byte 24,24,24,24,24,24,24,24
	byte 28,28,28,28,28,28,28,28
	byte 32,32,32,32,32,32,32,32
	byte 36,36,36,36,36,36,36,36
	byte 40,40,40,40,40,40,40,40
	byte 44,44,44,44,44,44,44,44
	byte 48,48,48,48,48,48,48,48
	byte 52,52,52,52,52,52,52,52
	byte 56,56,56,56,56,56,56,56
	byte 60,60,60,60,60,60,60,60
	byte 64,64,64,64,64,64,64,64
	byte 68,68,68,68,68,68,68,68
	byte 72,72,72,72,72,72,72,72
	byte 76,76,76,76,76,76,76,76
	byte 80,80,80,80,80,80,80,80

div13
;	byte 12,12,12,12,12,12,12,12,12,12,12,12,12
	byte 11,11,11,11,11,11,11,11,11,11,11,11,11
	byte 10,10,10,10,10,10,10,10,10,10,10,10,10
	byte 9,9,9,9,9,9,9,9,9,9,9,9,9
	byte 8,8,8,8,8,8,8,8,8,8,8,8,8
	byte 7,7,7,7,7,7,7,7,7,7,7,7,7
	byte 6,6,6,6,6,6,6,6,6,6,6,6,6
	byte 5,5,5,5,5,5,5,5,5,5,5,5,5
	byte 4,4,4,4,4,4,4,4,4,4,4,4,4
	byte 3,3,3,3,3,3,3,3,3,3,3,3,3
	byte 2,2,2,2,2,2,2,2,2,2,2,2,2
	byte 1,1,1,1,1,1,1,1,1,1,1,1,1
	byte 0,0,0,0,0,0,0,0,0,0,0,0,0





; HAS TO STAY WITH gameLogic
;--------------------------------------------------------------------------
; Power Up Handlers
;--------------------------------------------------------------------------
handlerArray
	word handle20PTS, handle20PTS, handle50PTS, handle100PTS, handle5SEC, handle10SEC, handle20SEC, handleWALLS, handle1UP, handleKEY


handle20PTS
	sed

	lda p1ScoreL,x
	clc
	adc #$20
	sta p1ScoreL,x
	
	lda p1ScoreH,x
	adc #0
	sta p1ScoreH,x

	cld

	jmp rtnHandler


handle50PTS
	sed
	
	lda p1ScoreL,x
	clc
	adc #$50
	sta p1ScoreL,x
	
	lda p1ScoreH,x
	adc #0
	sta p1ScoreH,x

	cld

	jmp rtnHandler


handle100PTS
	sed	

	lda p1ScoreH,x
	clc
	adc #$01
	sta p1ScoreH,x
	
	cld

	jmp rtnHandler


handle5SEC
	sed	

	lda p1TimeH,x
	clc
	adc #$05
	sta p1TimeH,x
	
	cld

	jmp rtnHandler


handle10SEC
	sed	

	lda p1TimeH,x
	clc
	adc #$10
	sta p1TimeH,x
	
	cld

	jmp rtnHandler


handle20SEC
	sed	

	lda p1TimeH,x
	clc
	adc #$20
	sta p1TimeH,x
	
	cld

	jmp rtnHandler


handleWALLS
	lda screen
	ora #%10000000
	sta screen

	jmp rtnHandler


handle1UP
	inc p1Lives,x

	jmp rtnHandler


handleKEY
	lda p1Status,x
	bne noReload

	lda #SCREENLOAD
	sta status
noReload

	jmp rtnHandler


colorCheckOffset
	byte 0,6


; HAS UP TO 4 SCREEN READS.   READS LEVEL DATA, COLORS, and calls CHECKPF
;--------------------------------------------------------------------------
; gameLogic
;--------------------------------------------------------------------------
; Handles general game logic for a player.
; 
; Preload:
; X: Player (0 or 1)
;
;--------------------------------------------------------------------------
gameLogic2

	; Reset timer when in startup mode
	lda status
	cmp #STARTUP
	bne noTimerReset

	; Reset time
	lda temp16H		; read this value in gameLogic (bank 2)
	sta p1TimeH,x
	
	lda #0
	sta p1TimeL,x
	
noTimerReset

	; ----------------------- Check for Finish
	ldy p1y,x
	lda div13,y
	lsr
	clc
	adc colorCheckOffset,x
	tay
	lda playField+60,y

	ldy #2

	; Check pf color
	cmp temp16L		; read this value in gameLogic (bank 2)
	bne notFinish1

	lda #FINISHED
	sta status

notFinish1
	

	; Check status
	lda status

	cmp #STARTUP
	beq resetPos1
	cmp #RESET
	bne noResetPos1

resetPos1
	; reset position
	ldy #4
	lda (screenL),y	
	sta p1x,x
	iny
	lda (screenL),y	
	sta p1y,x

	; reset velocity
	lda #128
	sta p1xVel,x
	sta p1yVel,x


noResetPos1
	lda status
	bne skipP1


	; -------------- Check for powerup collision

	; Check to see if the collision is for this player
	lda frame
	and #1
	cmp player
	bne noCollision

	; See if there's a player/missle1 colision
	lda CXM1P
	and #%11000000
	beq noCollision

	; Call power up handler using indirect jump
	lda p1Lives,x
	and #$F0
	lsr
	lsr
	lsr
	tay
	lda handlerArray,y
	sta pfBuffer
	iny
	lda handlerArray,y
	sta pfBuffer+1


	; jmp to handler
	jmp (pfBuffer)
rtnHandler

	; Stop displaying the power up
	lda #0
	sta pwr1y,x

	; flag that power up was "gotten"
	ldy #9
	lda (screenL),y
	ora pwrArray1,x
	sta pwrArray1,x


noCollision

	; --------------Y coord


	; save y position in temp2
	lda p1y,x
	sta temp2

	; Get paddle value from table (0-15)
	ldy padVal1,x
	lda paddleDecode2,y

	ldy p1yVel,x

	jsr calcMovement	; FUNCTION CALL

	jmp checkYPosition	; FUNCTION CALL
rtnCheckYPosition

	ldx player
	sta p1y,x
	sty p1yVel,x

	; --------------X coord

	;jmp skipP1


	; Store x position in temp2
	lda p1x,x
	sta temp2

	; Get paddle value from table (0-15)
	ldy padVal2,x
	lda paddleDecode2,y

	ldy p1xVel,x

	jsr calcMovement	; FUNCTION CALL

	jmp checkXPosition	; FUNCTION CALL
rtnCheckXPosition

	ldx player
	sta p1x,x
	sty p1xVel,x


skipP1

	;---------------------- check for time up

	lda status
	bne noFallOff1

	; Check for time up
	lda p1TimeL,x
	bne noTimeUp
	lda p1TimeH,x
	bne noTimeUp

	lda #150
	sta p1Counter,x

	lda #TIMEUP
	sta status
	
	jmp decLives

noTimeUp
	
	; ------------------------ check fall off

	lda screen
	bpl noWalls

	; Check for wall collision and adjust position/vel
	jmp wallCheck

noWalls

	; Check for fall off
	lda p1x,x
	ldy p1y,x
	
	jsr checkPlayfield	; FUNCTION CALL

	bne noFallOff1

	; Restore player index
	ldx player
	lda status
	bne noFallOff1

	lda #FALLOFF
	sta status

decLives

	; Decrement lives
	lda p1Lives,x
	sec
	sbc #1
	sta p1Lives,x
	and #$0F
	cmp #$0F

	bne notGameOver

	lda #GAMEOVER
	sta status

	lda #0
	sta p1Lives,x

notGameOver

	lda #50
	sta p1Counter,x

rtnWallCheck
noFallOff1

	ldx player

	; restore status
	lda status
	sta p1Status,x

	; restore screen
	lda screen
	sta p1Screen,x

	jmp rtnGameLogic2




yReset
	byte 5,5,5,5,5,5,5,5
	byte 13,13,13,13,13,13,13,13,13,13,13,13,13
	byte 26,26,26,26,26,26,26,26,26,26,26,26,26
	byte 39,39,39,39,39,39,39,39,39,39,39,39,39
	byte 52,52,52,52,52,52,52,52,52,52,52,52,52
	byte 65,65,65,65,65,65,65,65,65,65,65,65,65
	byte 78,78,78,78,78,78,78,78,78,78,78,78,78
	byte 91,91,91,91,91,91,91,91,91,91,91,91,91
	byte 104,104,104,104,104,104,104,104,104,104,104,104,104
	byte 117,117,117,117,117,117,117,117,117,117,117,117,117
	byte 130,130,130,130,130,130,130,130,130,130,130,130,130
	byte 143,143,143,143,143,143,143,143,143,143,143,143,143
	byte 156,156,156,156,156,156,156,156,156,156,156,156,156	

xReset
	byte 0,0
	byte 4,4,4,4
	byte 8,8,8,8
	byte 12,12,12,12
	byte 16,16,16,16
	byte 20,20,20,20
	byte 24,24,24,24
	byte 28,28,28,28
	byte 32,32,32,32
	byte 36,36,36,36
	byte 40,40,40,40
	byte 44,44,44,44
	byte 48,48,48,48
	byte 52,52,52,52
	byte 56,56,56,56
	byte 60,60,60,60
	byte 64,64,64,64
	byte 68,68,68,68
	byte 72,72,72,72
	byte 76,76,76,76
	byte 80,80,80,80
	byte 84,84,84,84
	byte 88,88,88,88
	byte 92,92,92,92
	byte 96,96,96,96
	byte 100,100,100,100
	byte 104,104,104,104
	byte 108,108,108,108
	byte 112,112,112,112
	byte 116,116,116,116
	byte 120,120,120,120
	byte 124,124,124,124
	byte 128,128,128,128
	byte 132,132,132,132
	byte 136,136,136,136
	byte 140,140,140,140
	byte 144,144,144,144

; ALWAYS READS 3 LEVEL PLAYFIELD BYTES (could be preloaded)
;--------------------------------------------------------------------------
; checkPlayfield
;--------------------------------------------------------------------------
; Determine if marble has fallen off / hit a wall
;
; Preload:
; A: marble x position
; Y: marble y position
; player must be loaded with the player#
;
; Return:
; A: 255 = safe, 0 = fall off
;--------------------------------------------------------------------------
checkPlayfield

	cpx #1
	beq checkPlayer2

	tax

	; Set up Y
	lda div13,y
	tay

	; Set up X
	lda div3t4,x
	tax

	; PF0
	lda collisions,x
	and #$F0
	and playField,y
	bne safe
	inx

	; PF1
	lda collisions,x
	and playField+12,y
	bne safe
	inx

	; PF2
	lda collisions,x
	and playField+24,y
	bne safe

	lda #0
	rts

safe
	
	lda #255
	rts

checkPlayer2

	tax

	; Set up Y
	lda div13,y
	tay

	; Set up X
	lda div3t4,x
	tax

	; PF0
	lda collisions,x
	and #$0F
	and playField,y
	bne safe
	inx

	; PF1
	lda collisions,x
	and playField+36,y
	bne safe
	inx

	; PF2
	lda collisions,x
	and playField+48,y
	bne safe

	lda #0
	rts



; CALLS CHECKPF TWICE, BUT NO SCREEN READS
;--------------------------------------------------------------------------
; wallCheck
;--------------------------------------------------------------------------
; Checks for wall collision and adjust position and velocity
; accordingly.  To be called from gameLogic function.
;--------------------------------------------------------------------------
wallCheck

	;------------------------- Check X axis for wall

	ldx player

	; Load correct X axis
	lda p1x,x

	; But load old Y axis
	ldy pMarble2+1
	
	jsr checkPlayfield	; FUNCTION CALL

	bne noXFallOff

	ldx player

	; The reset needs to be
	; adjusted based on the X movement direction
	ldy p1xVel,x
	bpl goingLeft

	; Bounce left
	lda p1xVel,x
	and #%01110000
	lsr
	lsr
	sta temp
	lda #128
	sbc temp
	and #%01111100
	sta p1xVel,x
		

	; Restore old X coordinate
	ldy pMarble2

	; Bias for moving right
	iny

	lda xReset,y

	sec
	sbc #2

	jmp endLeft

goingLeft

	; Bounce right
	lda #128
	sec
	sbc p1xVel,x
	lsr
	lsr
	and #%11111100
	ora #128
	sta p1xVel,x

	; Restore old X coordinate
	ldy pMarble2
	lda xReset,y

	sec
	sbc #1
endLeft

	sta p1x,x

noXFallOff


	;------------------------- Check Y axis for wall

	ldx player

	; Get positions (X is now adjusted if needed)
	lda p1x,x
	ldy p1y,x
	
	jsr checkPlayfield	; FUNCTION CALL

	bne noYFallOff

	ldx player

	; If the Y velocity is in the downward direction,
	; the reset position needs to be biased up
 	; (to avoid being stuck in a wall)
	ldy p1yVel,x
	bpl goingUp

	; Bounce up
	lda p1yVel,x
	and #%01100000
	lsr
	lsr
	sta temp
	lda #128
	sbc temp
	and #%01111100
	sta p1yVel,x
		

	; Restore old Y coordinate using lookup table
	ldy pMarble2+1
	lda yReset,y

	sec
	sbc #1

	sta p1y,x
	
	jmp endUp

goingUp

	; Bounce down
	lda #128
	sec
	sbc p1yVel,x
	lsr
	lsr
	and #%11111100
	ora #128
	sta p1yVel,x

	; Restore old Y coordinate using lookup table
	ldy pMarble2+1
	lda yReset,y

	sta p1y,x

endUp

noYFallOff

	jmp rtnWallCheck




;------------------------------------------------------------------------
; loadScreen2
;------------------------------------------------------------------------
; load the playfield data for player 1 and/or 2 as needed
;
; Preload:
; X: player to process (0 or 1)
;------------------------------------------------------------------------
loadScreen2

	lda p1Status,x
	cmp #INACTIVE
	bne normalDisplay

	;------------------- inactive screen setup

	; Get screen pointer

	lda beat	;;;;;;;;;;;;;;;;;;;;;;;; LEVEL POINTER READ

	lsr
	lsr
;	lsr
	and #%00000110
	tay
	lda level0,y
	sta screenL
	iny
	lda level0,y
	sta screenH


	lda measure
	asl
	asl
	asl
	asl
	and #%00110000
	sta pfBuffer
	lda pfColor
	and #%11001111
	ora pfBuffer

	cpx #0
	bne rightInactive

	; Copy in colors
	ldy #5
leftLoop5
	sta playField+60,y
	dey
	bpl leftLoop5

	jmp noColorLeftCopy

rightInactive


	; Copy in colors
	ldy #5
rightLoop5
	sta playField+66,y
	dey
	bpl rightLoop5

	jmp noColorRightCopy



	;--------------------- normal screen setup
normalDisplay

	; x y type mask keymask altlevel

	; Check for alternate screen key
	lda pwrArray1,x
	ldy #10		; 52 = key mask
	and (pMarble2),y 			;;;;;;;;;;;;;;;;;; CONTROL READ
	cmp (pMarble2),y
	bne noAltScreen	

	; Get alternate screen pointer
	ldy #11
	lda p1Screen,x
	and #%11100000
	ora (pMarble2),y			;;;;;;;;;;;;;;; CONTROL READ
	
	sta p1Screen,x

	lda #LOADREADY
	sta p1Status,x
	
	;******************
	;QUIT FUNCTION HERE
	;******************

	jmp rtnLoadScreen2

noAltScreen

	; See if power up has got gotten
	ldy #9			; 51 = power up mask
	lda pwrArray1,x
	and (pMarble2),y			;;;;;;;;;;;;;;; CONTROL READ
	bne clearPowerUp

	; Get powerup position
	ldy #6
	lda (pMarble2),y			;;;;;;;;;;;;;;;; CONTROL READ
	sta pwr1x,x
	ldy #7
	lda (pMarble2),y
	sta pwr1y,x

	; Get powerup type
	; The powerup type is stored in the upper 4 bits of the lives variable
	ldy #8
	lda (pMarble2),y			;;;;;;;;;;;;;; CONTROL READ
	and #$F0
	sta temp5
	lda p1Lives,x
	and #$0F
	ora temp5

	sta p1Lives,x

	jmp endPowerUp

clearPowerUp
	lda #0
	sta pwr1y,x
	lda p1Lives,x
	and #$0F
	sta p1Lives,x

endPowerUp

	cpx #0
	bne rightCopy

leftCopy
	;------------------------- Left Copy

	; Copy in colors
	ldy #5
leftLoop3
	lda (temp),y
	sta playField+60,y
	dey
	bpl leftLoop3

noColorLeftCopy

	; Copy in left side PF1 and PF2
	ldy #35
	ldx #23					;;;;;;;;;;;;;;; PF DATA
leftLoop1
	lda (screenL),y
	sta playField+12,x
	dey
	dex
	bpl leftLoop1

	; OR in left side PF0
	ldx temp16L
	ldy #11
leftLoop2
	lda (screenL),y
	and #$F0
	sta temp16L
	lda playField,y
	and #$0F
	ora temp16L
	sta playField,y
	dey
	bpl leftLoop2
	stx temp16L

	;*****************
	; QUIT LOADLEVEL2
	;*****************

	jmp rtnLoadScreen2


rightCopy
	;-------------------------- Right Copy

	; Copy in colors
	ldy #5
rightLoop3
	lda (temp),y
	sta playField+66,y
	dey
	bpl rightLoop3

noColorRightCopy

	; Copy in right PF1 and PF2
	ldy #35
	ldx #23
rightLoop
	lda (screenL),y
	sta playField+36,x
	dey
	dex
	bpl rightLoop

	; OR in right side PF0
	ldx temp16L
	ldy #11
rightLoop2
	lda (screenL),y
	and #$0F
	sta temp16L
	lda playField,y
	and #$F0
	ora temp16L
	sta playField,y
	dey
	bpl rightLoop2
	stx temp16L

	;****************
	;QUIT LOAD LEVEL2
	;****************
	
	jmp rtnLoadScreen2




level0
	word lev03, lev00, lev01, lev02



lev00
	;PF1/2
	byte %00000000	; screen data
	byte %11111111
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00110011
	byte %11111111
	byte %00000000

	;PF1.1
	byte %00000000
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00001111
	byte %00001111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %00000000

	;PF1.2
	byte %00000000
	byte %01111111
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01000000
	byte %01111111
	byte %00000000

lev01
	;PF1/2
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	
	;PF1.1
	byte %11111111	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00111111
	byte %00110000
	byte %00110000
	byte %00111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111

	;PF1.2
	byte %01111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000011
	byte %00000011
	byte %00000011
	byte %00000011
	byte %00000000
	byte %00000000
	byte %00000000
	byte %01111111

lev02
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11000000
	byte %11000000
	byte %11000000
	byte %11000000
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00011111
	byte %00011000
	byte %00011000
	byte %00011000
	byte %00011000
	byte %00011111
	byte %00000000
	byte %00000000
	byte %00000000
	
lev03
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00111111
	byte %00110000
	byte %00110000
	byte %00110000
	byte %00110000
	byte %00110000
	byte %00110000
	byte %00111111
	byte %00000000
	byte %00000000


lev10
	;PF1/2
	byte %00000000	; screen data
	byte %00110011
	byte %00110011
	byte %00110011
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111

	;PF1.2
	byte %00000000
	byte %01100000
	byte %01100000
	byte %01100000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	
col10
	; colors
	byte $06
	byte $A2
	byte $06
	byte $06
	byte $06
	byte $06

cont10
	byte 1		; next up
	byte 255	; next down
	byte 255	; next left
	byte 255	; next right

	byte 70		; reset x
	byte 112	; reset y
	byte 39		; powerup x
	byte 4		; powerup y
	byte HPWRWALLS	; powerup type
	byte 16		; powerup mask

	byte 1		; key mask
	byte 5		; alternate screen


col11
col12
col13
col14
col16
	; colors
	byte $06
	byte $06
	byte $06
	byte $06
	byte $06
	byte $06

cont11
	byte 255	; next up
	byte 0		; next down
	byte 255	; next left
	byte 2		; next right

	byte 70		; reset x
	byte 145	; reset y
	byte 39		; powerup x
	byte 11		; powerup y
	byte HPWRKEY; powerup type
	byte 1		; powerup mask

	byte 255	; key mask
	byte 1		; alternate screen

lev12
	;PF1/2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000

	;PF2.1
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000

	;PF2.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %01111111
	byte %01111111
	byte %01111111
	byte %00000000
	byte %00000000
	byte %00000000


cont12
	byte 255	; next up
	byte 255		; next down
	byte 1		; next left
	byte 3		; next right

	byte 7		; reset x
	byte 55		; reset y
	byte 0 		; powerup x
	byte 0 		; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 2		; alternate screen



cont13
	byte 255	; next up
	byte 4		; next down
	byte 2		; next left
	byte 255	; next right

	byte 7		; reset x
	byte 55		; reset y
	byte 39		; powerup x
	byte 4		; powerup y
	byte HPWR50PTS	; powerup type
	byte 2		; powerup mask

	byte 255	; key mask
	byte 3		; alternate screen

lev13
	;PF1/2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000

	;PF2.1
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000

	;PF2.2
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000

lev14
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %01111111
	byte %01111111
	byte %01111111
	byte %01111100
	byte %01111111
	byte %01111111 
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111

	;PF1.2
	byte %00000000
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011110
	byte %00011110
	byte %00011110
	byte %01111110
	byte %01111110
	byte %01111110
	byte %00000000
	byte %00000000
	

cont14
	byte 3		; next up
	byte 255	; next down
	byte 255	; next left
	byte 6	; next right

	byte 70		; reset x
	byte 10		; reset y
	byte 35 		; powerup x
	byte 5 		; powerup y
	byte HPWR10SEC	; powerup type
	byte 32		; powerup mask

	byte 255	; key mask
	byte 4		; alternate screen


lev15
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11001100
	byte %11001100
	byte %11001100
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00011111
	byte %00011111
	byte %00011111
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111

	;PF1.2
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000

lev11
	;PF1/2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF2.1
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00000000

	;PF2.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %01111111
	byte %01111111
	byte %01111111
	byte %00000000
	byte %00000000
	byte %00000000


	
col15
	; colors
	byte $06
	byte $A2
	byte $06
	byte $06
	byte $06
	byte $06

cont15
	byte 1	; next up
	byte 255	; next down
	byte 255	; next left
	byte 255	; next right

	byte 70		; reset x
	byte 117	; reset y
	byte 20		; powerup x
	byte 7		; powerup y
	byte HPWR100PTS	; powerup type
	byte 8		; powerup mask

	byte 255	; key mask
	byte 5		; alternate screen

lev29
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111110
	byte %00001110
	byte %00001110
	byte %00011111
	byte %00011111
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

lev16
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %11111111
	byte %11111111
	byte %11111111
	byte %11111100
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00111110
	byte %00111110
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	

cont16
	byte 255	; next up
	byte 7	; next down
	byte 4	; next left
	byte 255	; next right

	byte 70		; reset x
	byte 117	; reset y
	byte 0		; powerup x
	byte 0		; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 6		; alternate screen

lev22
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11001100
	byte %01110111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000010
	byte %00000010
	byte %00000010
	byte %00000010
	byte %11111010
	byte %00101010
	byte %00101110
	byte %00101000
	byte %00101000
	byte %00111000
	byte %00010000
	byte %00010000

	;PF1.2
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000

lev17
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00111110
	byte %00111110
	byte %00111110
	byte %00111110
	
col17
	; colors
	byte $06
	byte $A3
	byte $06
	byte $06
	byte $06
	byte $06

cont17
	byte 6	; next up
	byte 255	; next down
	byte 255	; next left
	byte 255	; next right

	byte 120		; reset x
	byte 20		; reset y
	byte 0		; powerup x
	byte 0		; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 7		; alternate screen


lev20
	;PF1/2
	byte %00000000	; screen data
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %11001100
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00111111
	byte %00111111
	byte %00111111
	byte %00110011
	byte %11110011
	byte %11110011
	byte %11110011
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %01111000
	byte %01111000
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00011111
	byte %00000000

col20	
	; colors
	byte $44
	byte $44
	byte $00
	byte $00
	byte $45
	byte $00

cont20
	byte 255	; next up
	byte 255	; next down
	byte 255	; next left
	byte 1		; next right

	byte 18		; reset x
	byte 126	; reset y
	byte 11 	; powerup x
	byte 3   	; powerup y
	byte HPWRWALLS		; powerup type
	byte 1		; powerup mask

	byte 255	; key mask
	byte 0		; alternate screen

lev21
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %01000000
	byte %00000010
	byte %00011111
	byte %11111111 
	byte %11111111
	byte %00000011
	byte %00000010
	byte %01000010
	byte %00010010
	byte %00000010

	;PF1.2
	byte %00000000
	byte %00001000
	byte %00000000
	byte %01000000
	byte %00000000
	byte %00100000
	byte %00000000
	byte %00000100
	byte %00000000
	byte %01000000
	byte %00000000
	byte %00000001
	
col21
col22
col23
col24
col26
col27
col28
	; colors
	byte $00
	byte $00
	byte $00
	byte $00
	byte $00
	byte $00

cont21
	byte 2		; next up
	byte 6		; next down
	byte 0		; next left
	byte 255	; next right

	byte 7		; reset x
	byte 84 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 2		; key mask
	byte 5		; alternate screen


	

cont22
	byte 3		; next up
	byte 1		; next down
	byte 4		; next left
	byte 255	; next right

	byte 7		; reset x
	byte 84 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 2		; alternate screen


lev23
	;PF1/2
	byte %00000000
	byte %00100010
	byte %00000000
	byte %00000000
	byte %10001000
	byte %10001000
	byte %00000000
	byte %00010001
	byte %00000000
	byte %00000000
	byte %01000100
	byte %00000000

	;PF1.1
	byte %00010010	; screen data
	byte %01010000
	byte %00010011
	byte %11111111
	byte %10111101
	byte %11111111
	byte %11101111
	byte %11111111
	byte %00000001
	byte %01000011
	byte %00000100
	byte %00010000

	;PF1.2
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000001 
	byte %00000000
	byte %00000011
	byte %00000001
	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000
;	byte %00000000

lev24
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %10001000
	byte %11001100
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00100010
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00100000
	byte %00000110
	byte %00110011
	byte %11111111
	byte %11110000
	byte %11110000
	byte %01111111
	byte %01101011
	byte %00001111
	byte %00000000
	byte %00000000

	;PF1.2
	byte %00000000
	byte %00100000
	byte %00000010
	byte %00000000
	byte %00011111
	byte %01111100
	byte %00011100
	byte %00000010
	byte %00100000
	byte %00000000
	byte %00001000
	byte %00000000
	

cont23
	byte 255	; next up
	byte 2		; next down
	byte 255	; next left
	byte 255	; next right

	byte 60		; reset x
	byte 90 	; reset y
	byte 50		; powerup x
	byte 10   	; powerup y
	byte HPWRKEY; powerup type
	byte 2		; powerup mask

	byte 255	; key mask
	byte 3		; alternate screen



	
cont24
	byte 255	; next up
	byte 255	; next down
	byte 255	; next left
	byte 2		; next right

	byte 45		; reset x
	byte 84 	; reset y
	byte 40		; powerup x
	byte 10   	; powerup y
	byte HPWR20SEC	; powerup type
	byte 4		; powerup mask

	byte 255	; key mask
	byte 4		; alternate screen



lev25
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00010000
	byte %00010000
	byte %01010000
	byte %00010010
	byte %00011111
	byte %11111111 
	byte %11111111
	byte %00000011
	byte %00000010
	byte %01000010
	byte %00010010
	byte %00000010

	;PF1.2
	byte %00000000
	byte %00001000
	byte %00000000
	byte %01000000
	byte %00000000
	byte %00100000
	byte %00000000
	byte %00000100
	byte %00000000
	byte %01000000
	byte %00000000
	byte %00000001
	
col25
	; colors
	byte $02
	byte $02
	byte $00
	byte $00
	byte $00
	byte $00

cont25
	byte 2		; next up
	byte 6		; next down
	byte 0		; next left
	byte 255	; next right

	byte 7		; reset x
	byte 84 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 5		; alternate screen


lev26
	;PF1/2
	byte %00000000	; screen data
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00010001
	byte %00000000
	byte %00000000
	byte %00100010
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %11111000
	byte %11111011
	byte %00001111
	byte %00011111
	byte %00000011
	byte %01000110
	byte %00000111
	byte %00010111
	byte %00111110
	byte %00010000
	byte %00010000

	;PF1.2
	byte %00000000
	byte %00000010
	byte %00100000
	byte %00000000
	byte %00000000
	byte %00000010
	byte %00001000
	byte %00000000
	byte %00000000
	byte %00100000
	byte %00000100
	byte %00000000
	

cont26
	byte 5		; next up
	byte 255	; next down
	byte 7		; next left
	byte 255	; next right

	byte 80		; reset x
	byte 52 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 8		; key mask
	byte 8		; alternate screen

lev27
	;PF1/2
	byte %00000000	; screen data
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00000000
	byte %00010001
	byte %00000000
	byte %00000000
	byte %00100010
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %00000000
	byte %00001111
	byte %01111100
	byte %01111100
	byte %00011111
	byte %00000111
	byte %00001110
	byte 111111101
	byte %11101000
	byte %11011100
	byte %00000000

	;PF1.2
	byte %00000000
	byte %01110010
	byte %01111111
	byte %00000111
	byte %00000000
	byte %00000010
	byte %00010000
	byte %00000000
	byte %01000000
	byte %00000000
	byte %00000100
	byte %00000000
	

cont27
	byte 255	; next up
	byte 5		; next down
	byte 255	; next left
	byte 6		; next right

	byte 55		; reset x
	byte 100 	; reset y
	byte 30		; powerup x
	byte 11   	; powerup y
	byte HPWRKEY; powerup type
	byte 8		; powerup mask

	byte 255	; key mask
	byte 7		; alternate screen


lev28
	;PF1/2
	byte %00000000	; screen data
	byte %11111111
	byte %11111111
	byte %00000000
	byte %00000000
	byte %00010001
	byte %00000000
	byte %00000000
	byte %00100010
	byte %00000000
	byte %00000000
	byte %00000000

	;PF1.1
	byte %00000000
	byte %11111000
	byte %11111011
	byte %00001111
	byte %00011111
	byte %00000011
	byte %01000110
	byte %00000111
	byte %00010111
	byte %00111110
	byte %00010000
	byte %00010000

	;PF1.2
	byte %00000000
	byte %00000010
	byte %00100000
	byte %00000000
	byte %00011000
	byte %01111111
	byte %00011000
	byte %00000000
	byte %00000000
	byte %00100000
	byte %00000100
	byte %00000000
	

cont28
	byte 5		; next up
	byte 255	; next down
	byte 7		; next left
	byte 9		; next right

	byte 80		; reset x
	byte 52 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 8		; alternate screen


	
col29
	; colors
	byte $00
	byte $45
	byte $00
	byte $00
	byte $45
	byte $00

cont29
	byte 255	; next up
	byte 255	; next down
	byte 8		; next left
	byte 255	; next right

	byte 7		; reset x
	byte 84 	; reset y
	byte 0 		; powerup x
	byte 0   	; powerup y
	byte 0		; powerup type
	byte 0		; powerup mask

	byte 255	; key mask
	byte 9		; alternate screen





;--------------------------------------------------------------------------
; gameLogic2 caller
;--------------------------------------------------------------------------
; call function then switch back to bank 2.
;--------------------------------------------------------------------------

	org $5FC3
	rorg $1FC3

	jmp gameLogic2
rtnGameLogic2
	stx BANK2 

;--------------------------------------------------------------------------
; loadScreen2 caller
;--------------------------------------------------------------------------
; call function then switch back to bank 2.
;--------------------------------------------------------------------------

	org $5FD3
	rorg $1FD3

	jmp loadScreen2
rtnLoadScreen2
	stx BANK2 



;--------------------------------------------------------------------------
; The cart may start up in this bank.  Make sure it switches
; back to bank 1 on startup.
;--------------------------------------------------------------------------
	org $5FED
	rorg $1FED

	lda BANK1

	org $5FFC	; Program startup vector
	.word $1FED
	.word $1FED

